


//Include misc functions
document.write("<script src='/admin/settings.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");

//global variables
//var changedSettingsDoc= null;
//var changedSettingsRoot;

var timeout;
var splashDiv;

var channelSettings ;
var temperatureSettings;
var auxInputSettings;



//Page element for ease of reference
var editDialog ;
var selChannel;
var selIrradiance;
var selTemperature;

var inputModDescription;
var inputModSystem;
var inputModSite;
var inputFixedVoltage;
var chkCurveEnabled;
var inputIntPeriod;
var inputPtrackVmin;
var inputPtrackVstep;
var inputApertureArea;
var inputTotalArea;
var tempTable;
var auxInputTable;
var irradTable;

var chanSettings;
var currentIndex;

var editSourceChannels;
var editDestChannelIds;

// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;

//////////////////////////////////////////////////////////////////////////////
function initialize()
{

	chanSettings = new channelSettings();
	temperatureSettings = new temperatureSettings();
	auxInputSettings = new auxInputSettings();
		
	//Get references to controls
	editDialog = document.getElementById("editListLayer");
		
	selChannel = document.getElementById('selChannel');
	selIrradiance = document.getElementById('selIrradiance');
	selTemperature = document.getElementById('selTemperature');
	
	inputModDescription = document.getElementById('inputModDescription');
	inputModSystem = document.getElementById('inputModSystem');
	inputModSite = document.getElementById('inputModSite');
	inputFixedVoltage = document.getElementById('fixedVoltage');
	chkCurveEnabled = document.getElementById('curvesEnabled');
	inputIntPeriod = document.getElementById('inputIntPeriod');
	inputPtrackVmin = document.getElementById('inputPtrackVmin');
	inputPtrackVstep = document.getElementById('inputPtrackVstep');
			
	inputApertureArea = document.getElementById('inputAptArea');
	inputTotalArea = document.getElementById('inputTotalArea');

	tempTable = document.getElementById('tempTable');
	initializeTable(tempTable, "Associated Temperatures");
	
	auxInputTable = document.getElementById('auxInputTable');
	initializeTable(auxInputTable, "Associated Aux Inputs");
		
	irradTable = document.getElementById('irradTable');
	initializeTable(irradTable, "Associated Irradiances");
		
	
	timeout = setTimeout(xmlTimeout, 2000);			
	chanSettings.getSettings();	//this call blocks	
	clearXmlTimeout();
		

	timeout = setTimeout(xmlTimeout, 2000);			
	auxInputSettings.getSettings();	//this call blocks	
	clearXmlTimeout();

	timeout = setTimeout(xmlTimeout, 2000);			
	temperatureSettings.getSettings();	//this call blocks	
	clearXmlTimeout();


	//Populate Channel Selection control
	selChannel.options.length = 0; //empty seleciton otpions
	for( var i=0; i < chanSettings.channels.length; i++ ) {
		var id = chanSettings.channels[i].id;
		selChannel.options[selChannel.options.length] = new Option(id, id);	
	}



	currentIndex = 0;
	updatePageValuesWithData(chanSettings.channels[currentIndex]);
	
	
	
}


//////////////////////////////////////////////////////////////////////////////
// update page with settings form given channel
function updatePageValuesWithData(channel)
{
	var i;
	
	inputModDescription.value = channel.description;
	inputModSystem.value = channel.system;
	inputModSite.value = channel.site;
	inputFixedVoltage.value = parseFloat(channel.fixedVoltage).toFixed(2);


	chkCurveEnabled.checked = channel.curvesEnabled;
	inputIntPeriod.value = parseFloat(channel.integrationPeriod).toFixed(0);
	inputPtrackVmin.value = parseFloat(channel.ptrackVmin).toFixed(2);
	inputPtrackVstep.value = parseFloat(channel.ptrackVstep).toFixed(2);
		
	inputApertureArea.value = parseFloat(channel.apertureArea).toFixed(4);
	inputTotalArea.value = parseFloat(channel.totalArea).toFixed(4);

	misc_setRadioValue(document.settings.powerModeGroup, channel.trackMode);
	
	updateAssociatedTables(channel);
/*
	updateTable(tempTable, channel.temperatureIds , temperatureSettings.channels )	;
	updateTable(irradTable, channel.irradianceIds, auxInputSettings.channels )	; //use aux inputs for irradiance
	updateTable(auxInputTable, channel.auxInputIds, auxInputSettings.channels );	
*/	
}// update Page


//////////////////////////////////////////////////////////////////////////////
function onSelectionChanged(channel)
{
	//current index actually holds teh selction index before this change
	updateDataWithPageValues();
	
	//now set the current index to the current selection index
	currentIndex = selChannel.selectedIndex;
	
	updatePageValuesWithData(chanSettings.channels[currentIndex]);
}

//////////////////////////////////////////////////////////////////////////////
function updateDataWithPageValues()
{
	//current index actually holds teh selction index before this change
	chanSettings.channels[currentIndex].description = inputModDescription.value;
	chanSettings.channels[currentIndex].system = inputModSystem.value;
	chanSettings.channels[currentIndex].site = inputModSite.value;
	chanSettings.channels[currentIndex].fixedVoltage = inputFixedVoltage.value;
	chanSettings.channels[currentIndex].curvesEnabled = chkCurveEnabled.checked;
	chanSettings.channels[currentIndex].integrationPeriod = inputIntPeriod.value;
	chanSettings.channels[currentIndex].ptrackVmin = inputPtrackVmin.value;
	chanSettings.channels[currentIndex].ptrackVstep = inputPtrackVstep.value;

	chanSettings.channels[currentIndex].apertureArea = inputApertureArea.value;
	chanSettings.channels[currentIndex].totalArea = inputTotalArea.value;
	
	chanSettings.channels[currentIndex].trackMode = misc_getRadioValue(document.settings.powerModeGroup);
	
	//extract table entries
	getTableIds(tempTable, chanSettings.channels[currentIndex].temperatureIds);
	getTableIds(irradTable, chanSettings.channels[currentIndex].irradianceIds);
	getTableIds(auxInputTable, chanSettings.channels[currentIndex].auxInputIds);
}


//////////////////////////////////////////////////////////////////////////////
function makeDirty()
{
	var index = selChannel.selectedIndex;
	chanSettings.channels[index].dirty = true;
}

//////////////////////////////////////////////////////////////////////////////
function onSaveButtonClick()
{
	//be sure to get data from current page
	updateDataWithPageValues();

	timeout = setTimeout(xmlTimeout, 1000);			
	chanSettings.setSettings();	//this call blocks	
	clearXmlTimeout();

}


//////////////////////////////////////////////////////////////////////////////
function initializeTable( table, captionText )
{		
//	var caption = table.createCaption()
//	caption.innerHTML=captionText ;
	
	//Create header row	
	table.createTHead();
	
	var headerRow = table.tHead.insertRow(-1);
	headerRow.className = "data_table_header";
	
	var newCell = headerRow.insertCell(0);
	newCell.innerHTML =  "Num";
	newCell.className = "data_table_header_cell";


	newCell = headerRow.insertCell(1);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(2);
	newCell.innerHTML =  "Description";
	newCell.className = "data_table_header_cell";

  	var tableBody = document.createElement("TBODY");
  	table.appendChild(tableBody);
}

//////////////////////////////////////////////////////////////////////////////
function updateTable(table, dataIds, channels)
{
	var i;
	var tBody = table.tBodies[0];
	
	//clear table
//	tBody.rows.length = 0;
	while (tBody.rows.length > 0 ) {
		tBody.deleteRow(0);
	}
	
	for( i=0; i < dataIds.length; i ++ ) {
		var newCell;
		
		//get channel referenced by ID value from channels 
		var channel = null;
		for( var n=0; n < channels.length; n++ ) {
			if (channels[n].id == dataIds[i] ) {
				channel = channels[n];
			}
		}
		
		//only add table entry if we found the matching entry in the given channels
		if ( channel != null ) {
			// add row to table
			var newRow = tBody.insertRow(-1);
			
			//add row # cell
			newCell = newRow.insertCell(0);
			newCell.innerHTML = i + 1; //display index base 1
			newCell.className = "data_table_cell";
			
			//add ID cell
			newCell = newRow.insertCell(1);
			newCell.innerHTML = dataIds[i];
			newCell.className = "data_table_cell";
			
			
			//add Description cell
			newCell = newRow.insertCell(2);
			newCell.innerHTML = channel.description;
			newCell.className = "data_table_cell";
			
		}//if channel null
	}
}


//////////////////////////////////////////////////////////////////////////////
function updateAssociatedTables(channel)
{
	updateTable(tempTable, channel.temperatureIds , temperatureSettings.channels )	;
	updateTable(irradTable, channel.irradianceIds, auxInputSettings.channels )	; //use aux inputs for irradiance
	updateTable(auxInputTable, channel.auxInputIds, auxInputSettings.channels );
}


///////////////////////////////////////////////////
//get sub set of the source channels with ids matching teh idArray
function getChannelsFromIds( sourceChannels, idArray)
{
	var resultChannels = new Array();
	
	for(var i=0; i < idArray.length; i++ ) {
		//get channel referenced by ID value from channels 
		for( var n=0; n < sourceChannels.length; n++ ) {
			if (sourceChannels[n].id == idArray[i] ) {
				resultChannels.push(sourceChannels[n]);
			}
		}
	
	}
	return resultChannels;
}


////////////////////////////////////////////////////////////////////////////////////////////
function getTableIds(table, dataIds)
{
	var i;
	var tBody = table.tBodies[0];
	
	dataIds.length = 0; //remove any exisitng entries
	for( i=0; i < tBody.rows.length; i++ ) {
		dataIds[i] = tBody.rows[i].cells[1].innerHTML;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////
function editList(button)
{
	var modChannel = chanSettings.channels[currentIndex];
		
	switch (button.id) {
		case "butEditTempList":	
			openEditDialog( temperatureSettings.channels, modChannel.temperatureIds, "System Temperatures","Associated Temperatures");
			break;
			
		case "butEditAuxInputList":
			openEditDialog( auxInputSettings.channels, modChannel.auxInputIds, "System Aux Inputs","Associated Aux Inputs");			
			break;

		case "butEditIrradList":
			openEditDialog( auxInputSettings.channels, modChannel.irradianceIds, "System Aux Inputs*","Associated Irradiances");			
			break;

		default:
			return;			
	}
}

////////////////////////////////////////////////////////////////////////////////////////////
function editDone()
{
	//make edit invisible
	editDialog.style.visibility = "hidden";

}

////////////////////////////////////////////////////////////////////////////////////////////
function openEditDialog( sourceChannels, destChannelIds, sourceLabelText, destLabelText)
{
	editSourceChannels = sourceChannels;
	editDestChannelIds = destChannelIds;
	
//	var destChannels = getChannelsFromIds(editSourceChannels , destChannelIds);


	//update labels
	document.getElementById("editSourceLabel").innerHTML = sourceLabelText;
	document.getElementById("editDestLabel").innerHTML = destLabelText;	

	//populate source list
	var sourceSel = document.getElementById("editSourceList");
	sourceSel.options.length = 0; //clear list
	
	for( var i=0; i < sourceChannels.length; i++ ) {
		var id = sourceChannels[i].id;
		var description = sourceChannels[i].description;
		
		var opt = document.createElement("option");
		opt.value = id;
		opt.text = id + "    " + description;
		sourceSel.add(opt, null);
	}
	
	populateEditDestList();

	//make edit dialog visible
	editDialog.style.visibility = "visible";
}


/////////////////////////////////////////////////////////////////////////////////////
function populateEditDestList()
{	
	var destChannels = getChannelsFromIds(editSourceChannels , editDestChannelIds);

	//populate destination list
	var destSel = document.getElementById("editDestList");
	destSel.options.length = 0; //clear list
	
	for( var i=0; i < destChannels.length; i++ ) {
		var id = destChannels[i].id;
		var description = destChannels[i].description;

		var opt = document.createElement("option");
		opt.value = id;
		opt.text = (i+1) + " " + id + "    " + description;
		destSel.add(opt, null);
	}
}

/////////////////////////////////////////////////////////////////////////////////////
function addToEditList()
{
	var sourceSel = document.getElementById("editSourceList");	

	//get the channel ID's of the selections in the source list and update the
	//settings with this. Then just update teh page and the edit box.
	
	var selectedOpt = sourceSel.options[sourceSel.selectedIndex];
	
	if ( selectedOpt == null ) {
		return;
	}
	
	var selId = selectedOpt.value;
	
	//make sure selected vlaue isn't alreayd in teh destination list
	for( var i=0; i < editDestChannelIds.length; i++ ) {
		if( editDestChannelIds[i] == selId ) {
			return; // selected chanel alreayd in list
		}
	}
	
	editDestChannelIds.push(selId);
	
	//rebuild destinaiton list (could have inserted but this is fast enough)
	populateEditDestList();
	
	//Rebuild main display list as well
	updateAssociatedTables(chanSettings.channels[currentIndex]);
	
	chanSettings.channels[currentIndex].dirty = true;	
}

////////////////////////////////////////////////////////////////////////////////////////////
function editRemove()
{
	var select = document.getElementById("editDestList");	
	
	var selectedOpt = select.options[select.selectedIndex];
	
	if ( selectedOpt == null ) {
		return;
	}

	var selId = selectedOpt.value;
	var index = -1;	
	//find index of match ID in ID array
	for( var i=0; i < editDestChannelIds.length; i++ ) {
		if( editDestChannelIds[i] == selId ) {
			//found it
			index = i;
			break; //exit loop
		}
	}
	
	if( index < 0 ) {
		return; //ID isn't in array
	}
	
	if ( index >= editDestChannelIds.length ) {
		return; //makes no sense so return
	}
	
	editDestChannelIds.splice(index, 1); //remove one vlaue form index locaiton

	//rebuild destinaiton list (could have inserted but this is fast enough)
	populateEditDestList();
	
	//Rebuild main display list as well
	updateAssociatedTables(chanSettings.channels[currentIndex]);

	chanSettings.channels[currentIndex].dirty = true;	
}


////////////////////////////////////////////////////////////////////////////////////////////
function editMoveUp()
{
	var select = document.getElementById("editDestList");	
	
	var selectedOpt = select.options[select.selectedIndex];
	
	if ( selectedOpt == null ) {
		return;
	}

	var selId = selectedOpt.value;
	var index = -1;	
	//find index of match ID in ID array
	for( var i=0; i < editDestChannelIds.length; i++ ) {
		if( editDestChannelIds[i] == selId ) {
			//found it
			index = i;
			break; //exit loop
		}
	}
	
	if( index < 1 ) {
		return; //ID isn't in array or is in top position already
	}
	
	if ( index >= editDestChannelIds.length ) {
		return; //makes no sense so return
	}
	
	//swap index with the one above it
	var tmpId = editDestChannelIds[index - 1]; //save this ID
	editDestChannelIds[index - 1] = editDestChannelIds[index];
	editDestChannelIds[index] = tmpId;
	

	//rebuild destinaiton list (could have inserted but this is fast enough)
	populateEditDestList();
	
	//Rebuild main display list as well
	updateAssociatedTables(chanSettings.channels[currentIndex]);

	chanSettings.channels[currentIndex].dirty = true;	


	select.selectedIndex = index -1; //keep the moved entry selected
}

////////////////////////////////////////////////////////////////////////////////////////////
function editMoveDown()
{
	var select = document.getElementById("editDestList");	
	
	var selectedOpt = select.options[select.selectedIndex];
	
	if ( selectedOpt == null ) {
		return;
	}

	var selId = selectedOpt.value;
	var index = -1;	
	//find index of match ID in ID array
	for( var i=0; i < editDestChannelIds.length; i++ ) {
		if( editDestChannelIds[i] == selId ) {
			//found it
			index = i;
			break; //exit loop
		}
	}
	
	if( index < 0 ) {
		return; //makes no sense
	}
	
	if ( index >= (editDestChannelIds.length -1 )) {
		return; //eitehr it is alreayd the last or index is out of bounds
	}
	
	//swap index with the one below it
	var tmpId = editDestChannelIds[index + 1]; //save this ID
	editDestChannelIds[index + 1] = editDestChannelIds[index];
	editDestChannelIds[index] = tmpId;
	

	//rebuild destinaiton list (could have inserted but this is fast enough)
	populateEditDestList();
	
	//Rebuild main display list as well
	updateAssociatedTables(chanSettings.channels[currentIndex]);

	chanSettings.channels[currentIndex].dirty = true;	


	select.selectedIndex = index + 1; //keep the moved entry selected


}

////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}


