


//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");
document.write("<script src='/user/tod_control.js' type='text/javascript'></script>");


//global variables
var xmlhttp;
var xmlSettingsDoc= null;
var timeout;
var splashDiv;

var startLayer;
var startTime;

var stopLayer;
var stopTime;

var intervalLayer;
var intervalCtrl;




// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;

//////////////////////////////////////////////////////////////////////////////
function initialize()
{
	xmlhttp = misc_getXmlRequestObject();
	
	
	startLayer = document.getElementById('start_time_layer');
	startTime = new todControl("Start Time");
	startLayer.appendChild(startTime.todDiv);

	stopLayer = document.getElementById('stop_time_layer');
	stopTime = new todControl("Stop Time");
	stopLayer .appendChild(stopTime.todDiv);

	intervalLayer= document.getElementById('interval_layer');
	intervalCtrl= new todControl("IV Curve Interval");
	intervalLayer.appendChild(intervalCtrl.todDiv);
	intervalCtrl.setHourLabel("Days");
	intervalCtrl.setMinLabel("Hours");
	intervalCtrl.setSecLabel("Min");
	
	getCurveSettings();
}

//////////////////////////////////////////////////////////////////////////////
// Asynchronously request settings
function getCurveSettings()
{
	if (xmlhttp!=null){
		xmlhttp.open("GET","/admin/curve_settings.xml",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onCurveSettingsResponse;  
		xmlhttp.send(null);
		timeout = setTimeout(xmlTimeout, 2000);
		//xmlTimeout();
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//get Settings

//////////////////////////////////////////////////////////////////////////////
function onCurveSettingsResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();
	
	var intDays;
	var intHours;
	var intMinutes;
	var intTod;
	var minIrrad, maxIrrad;
	var hour, min, sec;

	//Get start time
	var startTimeElem= xmlhttp.responseXML.documentElement.getElementsByTagName("StartTime")[0];
	if( startTimeElem!= null ) {
		hour = startTimeElem.getAttribute("hour");
		min = startTimeElem.getAttribute("min");
		sec = startTimeElem.getAttribute("sec");
	}else{
		hour = 0;	//set to start of day
		min = 0;
		sec = 0;
	}
	startTime.setTime(hour, min, sec);

	//Get stop time
	var stopTimeElem= xmlhttp.responseXML.documentElement.getElementsByTagName("StopTime")[0];
	if( stopTimeElem!= null ) {
		hour = stopTimeElem.getAttribute("hour");
		min = stopTimeElem.getAttribute("min");
		sec = stopTimeElem.getAttribute("sec");
	}else{
		hour = 23;	//set to end of day
		min = 59;
		sec = 59;
	}
	stopTime.setTime(hour, min, sec);
	
	//Get curve interval
	var curveElem = xmlhttp.responseXML.documentElement.getElementsByTagName("Curves")[0];
	if( curveElem != null ) {
		var intTotalSeconds = curveElem.getAttribute("interval");
		intDays = Math.floor(intTotalSeconds / NUM_SEC_PER_DAY );
		intTotalSeconds = intTotalSeconds  - intDays * NUM_SEC_PER_DAY;
		intTod = new time_of_day(intTotalSeconds );
		intHours = intTod.getHours();
		intMinutes = intTod.getMinutes();
		
		minIrrad = parseFloat(curveElem.getAttribute("irrad_min"));
		maxIrrad = parseFloat(curveElem.getAttribute("irrad_max"));
		
		irradFilterEnabled = curveElem.getAttribute("irrad_filter_enabled");
	}else{
		intDays = 0; //default to once an hour
		intHours = 1;
		intMinutes = 0;
		
		minIrrad = 0;
		maxIrrad = 1200;
	}
	intervalCtrl.setTime(intDays , intHours , intMinutes);
	
/*	SAVE THIS for when irradiance windowing is enabled
	document.getElementById('min_irrad').value = minIrrad ;
	document.getElementById('max_irrad').value = maxIrrad ;

	if( irradFilterEnabled  == "yes" ) {
		document.getElementById('enable_irrad_filter').checked = true; ;	
	}else{
		document.getElementById('enable_irrad_filter').checked = false ;	
	}
	
	*/
} // on Reponse serttings


//////////////////////////////////////////////////////////////////////////////
// Asynchronously set global settings
function setCurveSettings()
{

	//create an XML document to send back settings
	xmlSettingsDoc= misc_createXmlDoc();
	
	var root = xmlSettingsDoc.createElement("CurveSettings");
	xmlSettingsDoc.appendChild(root );

	var curvesElem = xmlSettingsDoc.createElement("Curves");
	root.appendChild(curvesElem );
	
	//Note: Using TimeOfDay control. In this case TOD hours = days, TO min = hours, TOD sec = min
	var interval = intervalCtrl.getHour() * NUM_SEC_PER_DAY;//really days
	interval = interval + intervalCtrl.getMin() * 3600; //really hours
	interval = interval + intervalCtrl.getSec() * 60; //really minutes
	

	curvesElem.setAttribute("interval", interval  );
	
/*	SAVE THIS for when irradiance windowing is enabled
	
	curvesElem.setAttribute("irrad_min", document.getElementById('min_irrad').value );
	curvesElem.setAttribute("irrad_max", document.getElementById('max_irrad').value );	
	
	if (document.getElementById('enable_irrad_filter').checked == true ) {
		curvesElem.setAttribute("irrad_filter_enabled", "yes" );		
	}else{
		curvesElem.setAttribute("irrad_filter_enabled", "no" );		
	}
*/
	
	var startTimeElem = xmlSettingsDoc.createElement("StartTime");
	curvesElem.appendChild(startTimeElem );
	startTimeElem.setAttribute("hour", startTime.getHour() );
	startTimeElem.setAttribute("min", startTime.getMin() );	
	startTimeElem.setAttribute("sec", startTime.getSec() );	
	
	
	var stopTimeElem = xmlSettingsDoc.createElement("StopTime");
	curvesElem .appendChild(stopTimeElem );
	stopTimeElem.setAttribute("hour", stopTime.getHour() );
	stopTimeElem.setAttribute("min", stopTime.getMin() );	
	stopTimeElem.setAttribute("sec", stopTime.getSec() );


	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/set_curve_settings",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onCurveSettingsResponse;  //read back settings
		xmlhttp.send(xmlSettingsDoc);
		timeout = setTimeout(xmlTimeout, 2000);
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//getSample

////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}

