//7-25-10
// Added gateway and DNS support


//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");


//global variables
var xmlhttp;
var timeout;
var splashDiv;


// form input references
var hostName;
var dhcpEnabled;
var ipAddress;
var subnet;
var gateway;
var dns1;
var dns2;
var mac;


// 
window.onload = initialize;

//////////////////////////////////////////////////////////////////////////////
// Asynchronously request settings
function initialize()
{
	xmlhttp = misc_getXmlRequestObject();
	
//	hostName = document.getElementById("inputHostName");
//	dhcpEnable = document.getElementById("chkEnableDHCP");
	ipAddress = document.getElementById("inputIpAddress");
	subnet = document.getElementById("inputSubnet");
	gateway = document.getElementById("inputGateway");
	dns1 = document.getElementById("inputDns1");
	dns2 = document.getElementById("inputDns2");	
	mac = document.getElementById("lblMac");	

	getNetworkSettings();
}

//////////////////////////////////////////////////////////////////////////////
// Asynchronously request settings
function getNetworkSettings()
{	
	if (xmlhttp!=null){
		xmlhttp.open("GET","/admin/network_settings.xml",false);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
//		xmlhttp.onreadystatechange = onNetworkSettingsResponse;  
		xmlhttp.send(null);
		timeout = setTimeout(xmlTimeout, 2000);
		
		onNetworkSettingsResponse()
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//get Settings

//////////////////////////////////////////////////////////////////////////////
function onNetworkSettingsResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}

	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}
	
	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}

	clearXmlTimeout();
	
	updateFormWithXml();
	
} // on Reponse serttings


//////////////////////////////////////////////////////////////////////////////
function updateFormWithXml()
{
	//Get network element
	var networkElem = xmlhttp.responseXML.documentElement.getElementsByTagName("Network")[0];
		
/* SAVE THIS for when we implemetn DHCP	
	hostName.value = networkElem.getAttribute("hostname");
	
	if( networkElem.getAttribute("dhcp") == "yes" ) {;
		dhcpEnable.checked = true;
	}else{
		dhcpEnable.checked = false;	
	}	
*/	
	ipAddress.value = networkElem.getAttribute("ipaddress");
	subnet.value = networkElem.getAttribute("netmask");
	gateway.value = networkElem.getAttribute("gateway");
	dns1.value = networkElem.getAttribute("dns1");
	dns2.value = networkElem.getAttribute("dns2");
	
	mac.innerHTML  = "MAC " + networkElem.getAttribute("macaddress");

}



//////////////////////////////////////////////////////////////////////////////
function updateXmlWithForm()
{
	//Get network element
	
	var changedSettingsDoc = misc_createXmlDoc();
	var changedSettingsRoot = changedSettingsDoc.createElement("Settings");
	changedSettingsDoc.appendChild(changedSettingsRoot);
	

	var networkElem = changedSettingsDoc.createElement("Network");
	changedSettingsRoot.appendChild(networkElem);
	
	/* SAVE THIS for when we implemetn DHCP	
	networkElem.setAttribute("hostname", hostName.value);
	
	if ( dhcpEnable.checked == true ) {
		networkElem.setAttribute("dhcp", "yes");
	}else{
		networkElem.setAttribute("dhcp", "no");	
	}
*/

	networkElem.setAttribute("ipaddress", ipAddress.value);
	networkElem.setAttribute("netmask", subnet.value );
	networkElem.setAttribute("gateway", gateway.value);
	networkElem.setAttribute("dns1", dns1.value);
	networkElem.setAttribute("dns2", dns2.value);
				
	return changedSettingsDoc;
}


//////////////////////////////////////////////////////////////////////////////
// Asynchronously set global settings
function setNetworkSettings()
{	
	var xmlDoc = updateXmlWithForm();

	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/set_network_settings",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onNetworkSettingsResponse;  //read back settings
		xmlhttp.send(xmlDoc);
		timeout = setTimeout(xmlTimeout, 2000);

	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//getSample



////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}



