


//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");
document.write("<script src='/user/tod_control.js' type='text/javascript'></script>");

//global variables
var xmlhttp;

var startLayer;
var startTime;

var stopLayer;
var stopTime;

var timeout;
var splashDiv;

// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;

//////////////////////////////////////////////////////////////////////////////
function initialize()
{
	xmlhttp = misc_getXmlRequestObject();
	
	startLayer = document.getElementById('start_time_layer');
	startTime = new todControl("Start Time");
	startLayer.appendChild(startTime.todDiv);

	stopLayer = document.getElementById('stop_time_layer');
	stopTime = new todControl("Stop Time");
	stopLayer .appendChild(stopTime.todDiv);

	getSampleSettings();
}

//////////////////////////////////////////////////////////////////////////////
// Asynchronously request settings
function getSampleSettings()
{
	if (xmlhttp!=null){
		xmlhttp.open("GET","/admin/sample_settings.xml",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onSampleSettingsResponse;  
		xmlhttp.send(null);
		timeout = setTimeout(xmlTimeout, 5000);
		//xmlTimeout();
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//get Settings

//////////////////////////////////////////////////////////////////////////////
function onSampleSettingsResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();
	
	var avgInterval;
	var hour, min, sec;

	//Get average interval
	var sampler = xmlhttp.responseXML.documentElement.getElementsByTagName("Sampler")[0];
	if( sampler != null ) {
		avgInterval= sampler.getAttribute("average_period")/ 60;
	}else{
		avgInterval = 10;	//set to start of day
	}
	document.getElementById('avg_int_input').value = avgInterval;

	//Get start time
	var startTimeElem= xmlhttp.responseXML.documentElement.getElementsByTagName("StartTime")[0];
	if( startTimeElem!= null ) {
		hour = startTimeElem.getAttribute("hour");
		min = startTimeElem.getAttribute("min");
		sec = startTimeElem.getAttribute("sec");
	}else{
		hour = 23;	//set to end of day
		min = 59;
		sec = 59;
	}
	startTime.setTime(hour, min, sec);


	//Get stop time
	var stopTimeElem= xmlhttp.responseXML.documentElement.getElementsByTagName("StopTime")[0];
	if( stopTimeElem!= null ) {
		hour = stopTimeElem.getAttribute("hour");
		min = stopTimeElem.getAttribute("min");
		sec = stopTimeElem.getAttribute("sec");
	}else{
		hour = 23;	//set to end of day
		min = 59;
		sec = 59;
	}
	stopTime.setTime(hour, min, sec);
	
} // on Reponse serttings


//////////////////////////////////////////////////////////////////////////////
// Asynchronously set global settings
function setSampleSettings()
{

	//create an XML document to send back settings
	xmlSettingsDoc= misc_createXmlDoc();
	
	var root = xmlSettingsDoc.createElement("Settings");
	xmlSettingsDoc.appendChild(root );

	var samplerElem = xmlSettingsDoc.createElement("Sampler");
	root.appendChild( samplerElem );
		
	samplerElem.setAttribute("average_period", document.getElementById('avg_int_input').value * 60 );

	//Start time
	var startTimeElem = xmlSettingsDoc.createElement("StartTime");
	samplerElem .appendChild(startTimeElem );
	startTimeElem.setAttribute("hour", startTime.getHour() );
	startTimeElem.setAttribute("min", startTime.getMin() );	
	startTimeElem.setAttribute("sec", startTime.getSec() );	
	
	//Stop time
	var stopTimeElem = xmlSettingsDoc.createElement("StopTime");
	samplerElem .appendChild(stopTimeElem );
	stopTimeElem.setAttribute("hour", stopTime.getHour() );
	stopTimeElem.setAttribute("min", stopTime.getMin() );	
	stopTimeElem.setAttribute("sec", stopTime.getSec() );

	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/set_sample_settings",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onSampleSettingsResponse;  //read back settings
		xmlhttp.send(xmlSettingsDoc);
		timeout = setTimeout(xmlTimeout, 5000);
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
	
}//getSample

////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{

	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";

}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}


