// Library of methods to get Multi-Tracer channel, temnpertaure and aux inoputs settings.
// Calls are block (wait for response).


//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");


//global variables


//////////////////////////////////////////////////////////////////////////////
function channelSettings()
{
	this.xmlhttp = misc_getXmlRequestObject();
	this.channels = new Array();

	/////////////////////////////
	this.getSettings = function getSettings()
	{
					
		if (this.xmlhttp!=null){
			this.xmlhttp.open("GET","/admin/channel_settings.xml",false); //false = wait frop response
			this.xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
	//		xmlhttp.onreadystatechange = onChannelSettingsResponse;  
			this.xmlhttp.send(null);
			this.onChannelSettingsResponse();
		}else{
			alert("Your browser does not support XMLHTTP.");
		}
	}//get Settings

	//////////////////////////////////////////////////////////////////////////////
	this.onChannelSettingsResponse = function onChannelSettingsResponse()
	{
		if(this.xmlhttp.readyState!=4){
			return;
		}
		
		if(this.xmlhttp.status == 0 ){
			//Ststus that seems to happen when we close a page with a pending request.
			return;
		}
	
		if(this.xmlhttp.status!=200){
			alert("Problem retrieving XML data");
			return;
		}
		
		var i;
	
		//Get array of channel settings
		var channelSettings = this.xmlhttp.responseXML.documentElement.getElementsByTagName("Channel");
		this.channels.length = 0;
		
		//fill array of channel settings
		for( i=0; i < channelSettings.length; i++ ) {
			this.channels[i] = new channelSetting(); //create new channel setting entry
			
			//extract values form XML settings data
			this.channels[i].id = channelSettings[i].getAttribute("id");
			this.channels[i].description = channelSettings[i].getAttribute("module_description");
			this.channels[i].system = channelSettings[i].getAttribute("system_description");
			this.channels[i].site = channelSettings[i].getAttribute("site_description");
			this.channels[i].trackMode = channelSettings[i].getAttribute("track_mode");
			this.channels[i].fixedVoltage = channelSettings[i].getAttribute("fixed_voltage");
			this.channels[i].ptrackVmin = channelSettings[i].getAttribute("ptrack_vmin");			
			this.channels[i].ptrackVstep = channelSettings[i].getAttribute("ptrack_vstep");	
			
			if( channelSettings[i].getAttribute("enable_curve") == "yes" ) {
				this.channels[i].curvesEnabled = true;		
			}else{
				this.channels[i].curvesEnabled = false;				
			}
			
			this.channels[i].integrationPeriod = channelSettings[i].getAttribute("average_usec");
			this.channels[i].apertureArea = channelSettings[i].getAttribute("aperture_area");
			this.channels[i].totalArea = channelSettings[i].getAttribute("total_area");
			
			//get array of ID's of associated temperatures
			var temps = channelSettings[i].getElementsByTagName("Temperature");		
			for( var n=0; n < temps.length; n++ ) {
				var id = temps[n].getAttribute("id");
				var index = temps[n].getAttribute("index");
				this.channels[i].temperatureIds[index] = id;
			}	

			//get array of ID's of associated irradiances
			var irrads = channelSettings[i].getElementsByTagName("Irradiance");		
			for( var n=0; n < irrads.length; n++ ) {
				var id = irrads[n].getAttribute("id");
				var index = irrads[n].getAttribute("index");
				this.channels[i].irradianceIds[index] = id;
			}
			

			//get array of ID's of associated temperatures
			var auxInputs = channelSettings[i].getElementsByTagName("AuxInput");		
			for( var n=0; n < auxInputs.length; n++ ) {
				var id = auxInputs[n].getAttribute("id");
				var index = auxInputs[n].getAttribute("index");
				this.channels[i].auxInputIds[index] = id;
			}
			
			this.channels[i].dirty = false;																			
		}

	} // on channel settigns response
	
	/////////////////////////////
	this.setSettings = function setSettings()
	{		
		var i;
		var n;
		var changedSettingsDoc= misc_createXmlDoc();
		var changedSettingsRoot = changedSettingsDoc.createElement("Settings");
		changedSettingsDoc.appendChild(changedSettingsRoot);
		

		var settingsElem = changedSettingsDoc.createElement("ModuleChannels");
		changedSettingsRoot.appendChild(settingsElem);


		for( i=0; i < this.channels.length; i++ ) {
			var channel = this.channels[i]; //for convenience
			
			if( channel.dirty == true ) {
		
				var elem = changedSettingsDoc.createElement("Channel");
				settingsElem.appendChild(elem);
			
				elem.setAttribute("id", channel.id );
				elem.setAttribute("module_description", channel.description);
				elem.setAttribute("system_description", channel.system );
				elem.setAttribute("site_description", channel.site );
				elem.setAttribute("track_mode", channel.trackMode);
				elem.setAttribute("fixed_voltage", channel.fixedVoltage);
				elem.setAttribute("average_usec", channel.integrationPeriod);		
				elem.setAttribute("ptrack_vmin", channel.ptrackVmin);						
				elem.setAttribute("ptrack_vstep", channel.ptrackVstep);	
					
				if( channel.curvesEnabled == true ) {
					elem.setAttribute("enable_curve", "yes");			
				}else{
					elem.setAttribute("enable_curve", "no");					
				}
				

				elem.setAttribute("aperture_area", channel.apertureArea);
				elem.setAttribute("total_area", channel.totalArea);


				var irradiances = changedSettingsDoc.createElement("Irradiances");
				elem.appendChild(irradiances);
				for( n = 0; n < channel.irradianceIds.length; n++ ) {
					var irrad = changedSettingsDoc.createElement("Irradiance");
					irradiances.appendChild(irrad);
					irrad.setAttribute("id", channel.irradianceIds[n] );
					irrad.setAttribute("index", n );					
				}
				
				var temperatures = changedSettingsDoc.createElement("Temperatures");
				elem.appendChild(temperatures);
				for( n = 0; n < channel.temperatureIds.length; n++ ) {
					var temp = changedSettingsDoc.createElement("Temperature");
					temperatures.appendChild(temp);
					temp.setAttribute("id", channel.temperatureIds[n] );
					temp.setAttribute("index", n );					
				}

				var auxInputs = changedSettingsDoc.createElement("AuxInputs");
				elem.appendChild(auxInputs);
				for( n = 0; n < channel.auxInputIds.length; n++ ) {
					var aux = changedSettingsDoc.createElement("AuxInput");
					auxInputs.appendChild(aux);
					aux.setAttribute("id", channel.auxInputIds[n] );
					aux.setAttribute("index", n );					
				}

				
			}//if channel dirty
		}// loop on channels
		

		
		if (this.xmlhttp!=null){
			this.xmlhttp.open("POST","/admin/set_channel_settings",false); //false = wait frop response
			this.xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
	//		xmlhttp.onreadystatechange = onChannelSettingsResponse;  
			this.xmlhttp.send(changedSettingsDoc);
			this.onChannelSettingsResponse (); //simply read the settings back in
		}else{
			alert("Your browser does not support XMLHTTP.");
		}
	}//set Settings


}//channel settings object

//////////////////////////////////////////////////////////////////////////////
// Object representing the settings of a single MT module channel
function channelSetting()
{
	//initialize values
	this.dirty = false;
	this.id = 0;
	this.description = "";
	this.system = "";
	this.site = "";
	this.trackMode = 0;
	this.fixedVoltage = -9999;
	this.integrationPeriod = 100; //100 uSeconds	
	this.ptrackVmin;
	this.ptrackVstep;
	
	this.curvesEnabled = false;

	this.apertureArea = 1;
	this.totalArea = 1;
	
	//Arrays of ID values of measurements to associate with this channel
	this.irradianceIds = new Array();
	this.temperatureIds = new Array();
	this.auxInputIds = new Array();
	
	
}




//////////////////////////////////////////////////////////////////////////////
function auxInputSettings()
{
	this.xmlhttp = misc_getXmlRequestObject();
	this.channels = new Array();

	this.getSettings = function getSettings()
	{
		if (this.xmlhttp!=null){
			this.xmlhttp.open("GET","/admin/aux_input_settings.xml",false);
			this.xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		//	xmlhttp.onreadystatechange = onAuxInputSettingsResponse;  
			this.xmlhttp.send(null);
		//	timeout = setTimeout(xmlTimeout, 2000);
			this.onSettingsResponse();
		}else{
			alert("Your browser does not support XMLHTTP.");
		}
	}//get Settings

	///////////
	this.onSettingsResponse = function onAuxInputSettingsResponse()
	{
		if(this.xmlhttp.readyState!=4){
			return;
		}
		
		if(this.xmlhttp.status == 0 ){
			//Status that seems to happen when we close a page with a pending request.
			return;
		}
		
		if(this.xmlhttp.status!=200){
			alert("Problem retrieving XML data");
			return;
		}
	
//		clearXmlTimeout();
		
		//build settings array
		var auxInputs = this.xmlhttp.responseXML.documentElement.getElementsByTagName("AuxInput");
		this.channels.length = 0;
		var i;
		//fill array of channel settings
		for( i=0; i < auxInputs.length; i++ ) {
			this.channels[i] = new auxInputSetting(); //create new channel setting entry
			
			//extract values form XML settings data
			this.channels[i].id = auxInputs[i].getAttribute("id");
			this.channels[i].description = auxInputs[i].getAttribute("description");
			this.channels[i].convertedReference = auxInputs[i].getAttribute("converted_ref");
			this.channels[i].voltageReference = auxInputs[i].getAttribute("voltage_ref");
			this.channels[i].convertedOffset = auxInputs[i].getAttribute("converted_offset");
			this.channels[i].convertedUnits = auxInputs[i].getAttribute("units");			
				
			this.channels[i].dirty = false;																			
		}

	}//onAuxInputSettingsResponse
	
	/////////////////////////////
	this.setSettings = function setSettings()
	{		
		var i;
		var changedSettingsDoc= misc_createXmlDoc();
		var changedSettingsRoot = changedSettingsDoc.createElement("AuxInputSettings");
		changedSettingsDoc.appendChild(changedSettingsRoot);

		for( i=0; i < this.channels.length; i++ ) {
			var channel = this.channels[i]; //for convenience
			
			if( channel.dirty == true ) {
		
				var elem = changedSettingsDoc.createElement("AuxInput");
				changedSettingsRoot.appendChild(elem);
			
				elem.setAttribute("id", channel.id );
				elem.setAttribute("description", channel.description);
				elem.setAttribute("converted_ref", channel.convertedReference );
				elem.setAttribute("converted_offset", channel.convertedOffset );
				elem.setAttribute("voltage_ref", channel.voltageReference );
				elem.setAttribute("units", channel.convertedUnits );
			}
		}
		

		
		if (this.xmlhttp!=null){
			this.xmlhttp.open("POST","/admin/set_aux_input_settings",false); //false = wait frop response
			this.xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
	//		xmlhttp.onreadystatechange = onChannelSettingsResponse;  
			this.xmlhttp.send(changedSettingsDoc);
			this.onSettingsResponse(); //simply read the settings back in
		}else{
			alert("Your browser does not support XMLHTTP.");
		}
	}//set Settings
	
	
	
}// auxInputSettings


//////////////////////////////////////////////////////////////////////////////
// Object representing the settings of a single MT aux input channel
function auxInputSetting()
{
	//initialize values
	this.dirty = false;
	this.id = 0;
	this.description = "";
	this.convertedReference = 1;
	this.voltageReference = 1;
	this.convertedOffset = 0;	
	this.convertedUnits = "";	

}




//////////////////////////////////////////////////////////////////////////////
function temperatureSettings()
{
	this.xmlhttp = misc_getXmlRequestObject();
	this.channels = new Array();

	this.getSettings = function getSettings()
	{
		if (this.xmlhttp!=null){
			this.xmlhttp.open("GET","/admin/temperature_settings.xml",false);
			this.xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		//	this.xmlhttp.onreadystatechange = onAuxInputSettingsResponse;  
			this.xmlhttp.send(null);
		//	timeout = setTimeout(xmlTimeout, 2000);
			this.onSettingsResponse();
		}else{
			alert("Your browser does not support XMLHTTP.");
		}
	}//get Settings

	///////////
	this.onSettingsResponse = function onTemperatureResponse()
	{
		if(this.xmlhttp.readyState!=4){
			return;
		}
		
		if(this.xmlhttp.status == 0 ){
			//Status that seems to happen when we close a page with a pending request.
			return;
		}
		
		if(this.xmlhttp.status!=200){
			alert("Problem retrieving XML data");
			return;
		}
	
//		clearXmlTimeout();
		
		//build settings array
		var temperatures = this.xmlhttp.responseXML.documentElement.getElementsByTagName("Temperature");
		this.channels.length = 0;
		var i;
		//fill array of channel settings
		for( i=0; i < temperatures.length; i++ ) {
			this.channels[i] = new temperatureSetting(); //create new channel setting entry
			
			//extract values form XML settings data
			this.channels[i].id = temperatures[i].getAttribute("id");
			this.channels[i].description = temperatures[i].getAttribute("description");
			
			this.channels[i].dirty = false;																			
		}
		
	}//onTemperatureSettingsResponse
	
	/////////////////////////////
	this.setSettings = function setSettings()
	{		
		var i;
		var changedSettingsDoc= misc_createXmlDoc();
		var changedSettingsRoot = changedSettingsDoc.createElement("TemperatureSettings");
		changedSettingsDoc.appendChild(changedSettingsRoot);

		for( i=0; i < this.channels.length; i++ ) {
			var channel = this.channels[i]; //for convenience
			
			if( channel.dirty == true ) {
		
				var elem = changedSettingsDoc.createElement("Temperature");
				changedSettingsRoot.appendChild(elem);
			
				elem.setAttribute("id", channel.id );
				elem.setAttribute("description", channel.description);
			}
		}
		
		if (this.xmlhttp!=null){
			this.xmlhttp.open("POST","/admin/set_temperature_settings",false); //false = wait frop response
			this.xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
	//		xmlhttp.onreadystatechange = onChannelSettingsResponse;  
			this.xmlhttp.send(changedSettingsDoc);
			this.onSettingsResponse(); //simply read the settings back in
		}else{
			alert("Your browser does not support XMLHTTP.");
		}
	}//set Settings
	
	
	
}// temperature Settings


//////////////////////////////////////////////////////////////////////////////
// Object representing the settings of a single MT temperature channel
function temperatureSetting()
{
	//initialize values
	this.dirty = false;
	this.id = 0;
	this.description = "";
	
}









