
//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/user/cookies.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");


//global variables
var curveTable;



var xmlhttp;
var takeCurveXmlHttp;
var xmlListDoc = null;


var voltsDigits = 3;
var ampsDigits = 3;
var powerDigits = 2;
var tempDigits = 1;
var fillDigits = 2;
var irradDigits = 2;
var auxPrecision = 6;

var timeout;
var splashDiv;

//column numbers
var COL_ID = 0;
var COL_SEL = 1;
var COL_NAME = 2;
var COL_POWER = 3;
var COL_VPEAK = 4;
var COL_IPEAK = 5;
var COL_VOC = 6;
var COL_ISC = 7;
var COL_FF = 8;
var COL_DATE = 9;
var COL_TIME = 10;
var COL_IRRAD1 = 11;
var COL_IRRAD2 = 12;
var COL_TEMP1 = 13;
var COL_TEMP2 = 14;

var UNKNOWN = " ";
var SELECTED_CURVES_COOKIE = "SelectedCurves";


// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;
window.onunload = onUnload;


//////////////////////////////////////////////////////////////////////////////
function initialize()
{
	//create a single instance once for each of the teo xml http request objects we need
	xmlhttp = misc_getXmlRequestObject();
	takeCurveXmlHttp = misc_getXmlRequestObject();

	
	//First rad in channel settings to get system schema
	getChannelSettings();
}


/*
///////////////////////////////////////////////////////////////////////////////
function initialize()
{

	
	//create new table
	tempTable = document.createElement("table");
	document.getElementById('curveTableLayer').appendChild(tempTable);	
	tempTable.className = "data_table";
	tempTable.id = "temperature_table";
		
	var caption = tempTable.createCaption();
	caption.innerHTML="Temperatures";

	//Created header row	
	tempTable.createTHead();
	
	var headerRow = tempTable.tHead.insertRow(-1);
	headerRow .className = "data_table_header";
	
	var newCell = headerRow.insertCell(0);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(1);
	newCell.innerHTML =  "Description";
	newCell.className = "data_table_header_cell";


  	var tableBody = document.createElement("TBODY");
  	tempTable.appendChild(tableBody);


  	//var tableBody = tempTable.tBodies[0];

	for ( var i=0; i < 8; i++){
		var id;
		var row = tableBody.rows[i];
		if( row == null ) {
			row = tableBody.insertRow(-1);
			
			//add cell for channel id
			var newCell = row.insertCell(0);
			newCell.className = "data_table_cell";
			
			//add cell for channel description
			newCell = row.insertCell(1);
			newCell.className = "data_table_cell";
			var newInput = document.createElement("input");
			newInput.setAttribute("name","description");
			newInput.setAttribute("type","text");
			newInput.setAttribute("onChange","inputChanged(this)");
			newCell.appendChild(newInput);
		}
		
		row.cells[0].innerHTML = i ;		
		row.cells[1].getElementsByTagName('input')[0].value = "gdhfg";
	}//end for i = 

} // initialize
*/


//////////////////////////////////////////////////////////////////////////////
// Asynchronously request channel settings
function getChannelSettings()
{
	if (xmlhttp!=null){
		xmlhttp.open("GET","/admin/channel_settings.xml",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onChannelSettingsResponse;  
		xmlhttp.send(null);
		timeout = setTimeout(xmlTimeout, 2000);
	//	xmlTimeout();
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//get channel Settings

//////////////////////////////////////////////////////////////////////////////
function onChannelSettingsResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}
	
	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();
		
	//Get array of chanenl elements
	var channels = xmlhttp.responseXML.documentElement.getElementsByTagName("Channel");

	//create an XML document to use for the list of curves ID's
	xmlListDoc = misc_createXmlDoc();
	var listElem = xmlListDoc .createElement("List");
	xmlListDoc.appendChild(listElem);
	
	listElem.setAttribute("points","no");
	
	var modId;
	var idElem;
	
	//Loop through channel setting to construct list of curves to request 		 
	for (var i=0; i < channels.length; i++){	
		try{	
			modId = channels[i].getAttribute("id");
			idElem = xmlListDoc.createElement("Id");
			idElem.setAttribute("id",modId);
			listElem.appendChild(idElem);

		}catch (er){
			modId = UNKNOWN;
		}		
	}//end for i = 	
	
	//build tabel matching list of modules
	var idList = xmlListDoc.getElementsByTagName("Id");
	if( idList != null ) {
		curveTable = buildTable( idList );
		try {
			document.getElementById('curveTableLayer').removeChild( curveTable  );//remove previous table (if any).
		}catch  (er) {
		}
		document.getElementById('curveTableLayer').appendChild(curveTable);
	}		
	//get data and fill table with it
	getCurveData();

} // on Reponse channel serttings


//////////////////////////////////////////////////////////////////////////////
// Asynchronously request a sample
function getCurveData()
{
	xmlhttp = misc_getXmlRequestObject();
	
	if (xmlhttp!=null){
		xmlhttp.open("POST","/user/last_curves.xml",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange=onGetCurvesResponse;  
		xmlhttp.send(xmlListDoc);
		timeout = setTimeout(xmlTimeout, 2000);
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//getSample



//////////////////////////////////////////////////////////////////////////////
//function buildTable( newTable, idList )
function buildTable( idList )
{
	var newTable;
	var selIdList;
	var newCell;
	var modId;
	var newRow;
	var newInput;
	var name;
	var value;
	var i;

	//create new table
	newTable = document.createElement("table");
	newTable.className = "data_table";
	newTable.id = "curve_table";
			
	var caption = newTable.createCaption()
	caption.innerHTML="IV Curves"

	//Created header row	
	newTable.createTHead();

	var headerRow = newTable.tHead.insertRow(-1);
	headerRow .className = "data_table_header";

	newCell = headerRow.insertCell(COL_ID);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(COL_SEL);
	newCell.innerHTML =  " ";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_NAME);
	newCell.innerHTML =  "Name";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_POWER);
	newCell.innerHTML =  "Pk Power";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_VPEAK);
	newCell.innerHTML =  "Vpeak";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_IPEAK);
	newCell.innerHTML =  "Ipeak";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_VOC);
	newCell.innerHTML =  "Voc";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_ISC);
	newCell.innerHTML =  "Isc";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_FF);
	newCell.innerHTML =  "FF (%)";
	newCell.className = "data_table_header_cell";
	
	newCell = headerRow.insertCell(COL_DATE);
	newCell.innerHTML =  "Date";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(COL_TIME);
	newCell.innerHTML =  "Time";
	newCell.className = "data_table_header_cell";
	
	
	newCell = headerRow.insertCell(COL_IRRAD1);
	newCell.innerHTML =  "Irrad 1";
	newCell.className = "data_table_header_cell";
	
	newCell = headerRow.insertCell(COL_IRRAD2);
	newCell.innerHTML =  "Irrad 2";
	newCell.className = "data_table_header_cell";
	

	newCell = headerRow.insertCell(COL_TEMP1);
	newCell.innerHTML =  "Temp 1";
	newCell.className = "data_table_header_cell";


	newCell = headerRow.insertCell(COL_TEMP2);
	newCell.innerHTML =  "Temp 2";
	newCell.className = "data_table_header_cell";
	
	

	//Before building table, look for cookie that holds selected rows form earlier sessions
	selIdList = GetCookie(SELECTED_CURVES_COOKIE);
	if ( selIdList == null ) {
		selIdList = "";	//make sure it isn't null
	}

	var tableBody = document.createElement("TBODY");
  	newTable.appendChild(tableBody);	



	for( i = 0; i < idList.length; i ++ ) {
		newRow = tableBody.insertRow(-1);	
		try{	
			modId = idList[i].getAttribute("id");
		}catch (er){
			modId = UNKNOWN;
		}
		
		newCell = newRow.insertCell(COL_ID);
		newCell.innerHTML = modId ;
		newCell.className = "data_table_cell";
	
		//insert selection checkbox
		newCell = newRow.insertCell(COL_SEL);
		newCell.className = "data_table_cell";
		newInput = document.createElement("input");
		newCell.appendChild(newInput);		
		newInput.setAttribute("type","checkbox");
		
		var str = "*" + modId + "*";
		if( selIdList .indexOf(str) != -1 ) {
			newInput.checked = true;		
		}else{
			newInput.checked = false;
		}
		
	
		newInput.setAttribute("onChange","selectChanged(this)"); 



		name = UNKNOWN;
		newCell = newRow .insertCell(COL_NAME);
		newCell.innerHTML = name;
		newCell.className = "data_table_cell";
		
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_POWER);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
		
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_VPEAK);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
		
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_IPEAK);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
		
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_VOC);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
		
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_ISC);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
	
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_FF);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
		
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_DATE);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
	
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_TIME);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
		
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_IRRAD1);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";

		value = UNKNOWN;
		newCell = newRow .insertCell(COL_IRRAD2);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";
			
		value = UNKNOWN;
		newCell = newRow .insertCell(COL_TEMP1);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";

		value = UNKNOWN;
		newCell = newRow .insertCell(COL_TEMP2);
		newCell.innerHTML = value;
		newCell.className = "data_table_cell";

	}//end for i = 

	return newTable;
} //onResponse


//////////////////////////////////////////////////////////////////////////////
function onUnload()
{
	//save curve seleciton check box setting in a cookie
	saveSelections();
	
	takeCurveXmlHttp.abort();
	takeCurveXmlHttp = null;
	
	xmlhttp.abort();
	xmlhttp = null;
}

//////////////////////////////////////////////////////////////////////////////
function saveSelections()
{

	//loop through each row and check if the selection box is checked.
	//If checked (selected) then and that row's ID value to the selection cookie
	var selIdList = "";
		
	//loop through each row of the table looking for a matching curve
	var tableBody = curveTable.tBodies[0];
	for( var i = 0; i < tableBody.rows.length; i ++ ) {
		var curveId;
		var curveIndex;
		var row = tableBody.rows[i]; //for convenience
		var rowId = row.cells[COL_ID].innerHTML;
		
		if ( row.cells[COL_SEL].firstChild.checked == true ) {
			selIdList = selIdList + "*" + rowId + "*";
		}
	}
	
	var expdate = new Date ();
	FixCookieDate (expdate); // Correct for Mac date bug - call only once for given Date object!
	expdate.setTime (expdate.getTime() + (10*365 * 24 * 60 * 60 * 1000)); // 10 years from now 

	//save list as cookie
	SetCookie(SELECTED_CURVES_COOKIE, selIdList, expdate );
}

//////////////////////////////////////////////////////////////////////////////
function takeAllCurves()
{
	disableTakeCurveButtons( true ); //disable take curve buttions during curves
	takeCurves(true);
}

//////////////////////////////////////////////////////////////////////////////
function takeSelectedCurves()
{
	disableTakeCurveButtons( true ); //disable take curve buttions during curves
	takeCurves(false);
}

//////////////////////////////////////////////////////////////////////////////
function takeCurves( allCurves )
{
	var idElem;
	var modId;
	
	//create an XML document to use for the list of curves ID's
	var xmlIdListDoc = misc_createXmlDoc();
	var listElem = xmlIdListDoc.createElement("List");
	xmlIdListDoc.appendChild(listElem);
	
	listElem.setAttribute("points","no"); //don't include points with return data
	
	//Loop through each row
	var tableBody = curveTable.tBodies[0];
	for( var i = 0; i < tableBody.rows.length; i ++ ) {
		var row = tableBody.rows[i]; //for convenience
		var rowId = row.cells[COL_ID].innerHTML;

		//Take this row's curve if allCurves or if row is selected
		if ( (allCurves == true) || (row.cells[COL_SEL].firstChild.checked == true) ) {
			try{	
				idElem = xmlIdListDoc .createElement("Id");
				idElem.setAttribute("id", rowId );
				listElem.appendChild(idElem);
	
			}catch (er){
				modId = UNKNOWN;
			}		
		}
	}//end for i = 
	
	//Send take curve request and setup to get response data.
	//xmlhttp = misc_getXmlRequestObject();
	
	if (takeCurveXmlHttp !=null){
		takeCurveXmlHttp.open("POST","/admin/take_curves",true);
		takeCurveXmlHttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		takeCurveXmlHttp.onreadystatechange = onTakeCurvesResponse;  
		
		takeCurveXmlHttp.send(xmlIdListDoc);
		
		timeout = setTimeout(takeIvCurvesMessage, 10);

	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}

//////////////////////////////////////////////////////////////////////////////
function onTakeCurvesResponse()
{

	if(takeCurveXmlHttp.readyState!=4){
		return;
	}
	
	if(takeCurveXmlHttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(takeCurveXmlHttp.status!=200){
		alert("Problem retrieving XML data. Status = " + takeCurveXmlHttp.status);
		return;
	}

	clearXmlTimeout();
	
	getCurvesResponse( takeCurveXmlHttp ); //get and display new data
	disableTakeCurveButtons( false ); //enable take curve buttions during curves	
}

//////////////////////////////////////////////////////////////////////////////
function disableTakeCurveButtons( isDisabled )
{
	document.getElementById('but_take_all_curves').disabled = isDisabled ;
	document.getElementById('but_take_sel_curves').disabled = isDisabled ;
}


//////////////////////////////////////////////////////////////////////////////
function onGetCurvesResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}
	
		
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}

	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearXmlTimeout();
		
	getCurvesResponse( xmlhttp );
	
	//set it up to automatically request new data
	setTimeout("getCurveData()", 10000);

}
//////////////////////////////////////////////////////////////////////////////
function getCurvesResponse( httpRequest )
{
	var value;
	var date_time;
	var irrad;
	var temp;
	var curves = httpRequest.responseXML.documentElement.getElementsByTagName("Curve");

	//loop through each row of the table looking for a matching curve
	var tableBody = curveTable.tBodies[0];
	for( var i = 0; i < tableBody.rows.length; i ++ ) {
		var curveId;
		var curveIndex;
		var row = tableBody.rows[i]; //for convenience

		var rowId = row.cells[COL_ID].innerHTML;
		var cell;
	
		//find IV curve with matching ID
		curveIndex = -1;
		for( var n = 0; n < curves.length; n++ ) {
			curveId = curves[n].getElementsByTagName("ModuleID")[0].firstChild.nodeValue;
			
			if ( curveId == rowId ) {			
				curveIndex = n; //save index of matching curve
				break; //stop looking
			}
		}

		//if match was found, update table with curve data
		if( curveIndex != -1 ) { //make sure a match was found
		
			try{	
				value = curves[curveIndex].getElementsByTagName("Name")[0].firstChild.nodeValue;
			}catch (er){
				value = UNKNOWN ;
			}
			row.cells[COL_NAME].innerHTML = value ;



			try{	
				value = parseFloat(curves[curveIndex].getElementsByTagName("PeakPower")[0].firstChild.nodeValue).toFixed(powerDigits);
			}catch (er){
				value = UNKNOWN ;
			}
			row.cells[COL_POWER].innerHTML = value ;

			try{	
				value = parseFloat(curves[curveIndex].getElementsByTagName("Vpeak")[0].firstChild.nodeValue).toFixed(voltsDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_VPEAK].innerHTML = value ;
		
			try{	
				value = parseFloat(curves[curveIndex].getElementsByTagName("Ipeak")[0].firstChild.nodeValue).toFixed(ampsDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_IPEAK].innerHTML = value ;
		
			try{	
				value = parseFloat(curves[curveIndex].getElementsByTagName("Voc")[0].firstChild.nodeValue).toFixed(voltsDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_VOC].innerHTML = value ;
		
			try{	
				value = parseFloat(curves[curveIndex].getElementsByTagName("Isc")[0].firstChild.nodeValue).toFixed(ampsDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_ISC].innerHTML = value ;
	
			try{	
				value = parseFloat(curves[curveIndex].getElementsByTagName("FillFactor")[0].firstChild.nodeValue).toFixed(fillDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_FF].innerHTML = value ;
					
			try{	
				date_time = curves[curveIndex].getElementsByTagName("Date_Time")[0];
				value = date_time.getAttribute("date");
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_DATE].innerHTML = value ;
	
			try{	
				date_time = curves[curveIndex].getElementsByTagName("Date_Time")[0];
				value = date_time.getAttribute("time");
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_TIME].innerHTML = value ;
		
			try{	
				irrad = curves[curveIndex].getElementsByTagName("Irrad1")[0];
				value =  parseFloat(irrad.getElementsByTagName("Value")[0].firstChild.nodeValue).toFixed(irradDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_IRRAD1].innerHTML = value ;

			try{	
				var irrad = curves[curveIndex].getElementsByTagName("Irrad2")[0];
				value =  parseFloat(irrad.getElementsByTagName("Value")[0].firstChild.nodeValue).toFixed(irradDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_IRRAD2].innerHTML = value ;
			
			try{	
				temp = curves[curveIndex].getElementsByTagName("Temp1")[0];
				value =  parseFloat(temp .getElementsByTagName("Value")[0].firstChild.nodeValue).toFixed(tempDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_TEMP1].innerHTML = value ;

			try{	
				temp = curves[curveIndex].getElementsByTagName("Temp2")[0];
				value =  parseFloat(temp .getElementsByTagName("Value")[0].firstChild.nodeValue).toFixed(tempDigits);
			}catch (er){
				value = UNKNOWN;
			}
			row.cells[COL_TEMP2].innerHTML = value ;;	
		}// if curve and row ID match found
	}//for loop through rows
} //onResponse


////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function takeIvCurvesMessage()
{
	splashDiv = getSplash("Taking IV Curves", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}


////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}

